Subject: Re: bug#78808: 28.2; Debian 12 GNU Emacs bug in Custom

From: Eli Zaretskii <[email-masked]>
Date: Sun, 06 Jul 2025 09:50:08 +0300

[Please use Reply All to reply, to keep the bug tracker CC'ed.]

> Date: Tue, 17 Jun 2025 15:02:44 +0300
> From: Barry Davidson <[email-masked]>
> 
> On Tue, 17 Jun 2025 14:09:36 +0300
> Eli Zaretskii <[email-masked]> wrote:
> 
> > > Date: Mon, 16 Jun 2025 15:49:13 +0300
> > > From:  Barry Davidson via "Bug reports for GNU Emacs,
> > >  the Swiss army knife of text editors" <[email-masked]>
> > > 
> > > After changing settings in Custom and after visiting and changing
> > > existing theme in customize-create-theme, Custom fails to put ( )
> > > around values for key :inherit. Example:
> > > It writes (:inherit link) instead of (:inherit (link)).
> > > Emacs then complains about errors in theme and if I visit it in
> > > customize-create-theme, then those fields are not properly
> > > displayed: instead of checkboxes there are just elisp code sections.
> > > I fixed my custom theme by manually adding parentheses ( ) after
> > > every :inherit keyword, like so: (:inherit (variable-pitch));
> > > Custom wrote it as (:inherit variable-pitch) without parentheses.  
> > 
> > Thank you for your report.  But please describe a detailed recipe for
> > reproducing this problem starting from "emacs -Q".  Please include all
> > the commands you typed, including the specific theme you tried and the
> > variables/faces you customized.  Such a detailed description is
> > important for efficiently investigating the problem and its source, if
> > it still exists in the latest releases of Emacs (the last released
> > version is 30.1, with 30.2 in the works and expected to be released
> > soon).
> emacs -Q, M-x customize-create-theme,
> Include basic face customizations in this theme? y
> Change colors of all Font Lock faces, except inherited ones.
> Save Theme. Then next day M-x customize-create-theme,
> Visit Theme, Font Lock Keyword Face and Font Lock Builtin Face - add
> Weight bold, Save Theme. Restart emacs and there are errors in
> *Messages*. M-x customize-create-theme, Visit Theme, click on arrows to
> show each face. Faces that inherit from other faces show just lisp code
> instead of checkboxes. For example, Font Lock Comment Delimiter Face.
> emacs -Q, M-x customize-create-theme,
> Include basic face customizations in this theme? y
> Save Theme. Then compare this theme to the one I've created. After
> studying the code I've noticed lack of parentheses ( ) around values
> for key :inherit. Adding parentheses manually fixed the problem. I can
> load the theme and when visiting in M-x customize-create-theme, the
> checkboxes are in place.

Thanks, and sorry for the long delay.

I tried this recipe now with what will soon become Emacs 30.2, and I
cannot reproduce the problems you are describing.  I see neither error
messages in *Messages* nor Lisp code instead of checkboxes in the face
descriptions.

You report these problems in Emacs 28.2, which is quite old, so
perhaps the problems were already fixed since then?  Can you try the
latest pretest of Emacs 30.2, available here:

  https://alpha.gnu.org/gnu/emacs/pretest/emacs-30.1.90.tar.xz

and see if the problems are gone?